import _createClass from "@babel/runtime/helpers/createClass";
import { TransformStage } from '@alilc/lowcode-types';
import Node from './node';
import { nodeSymbol, nodeChildrenSymbol } from './symbols';

var NodeChildren = /*#__PURE__*/function () {
  function NodeChildren(nodeChildren) {
    this[nodeChildrenSymbol] = void 0;
    this[nodeChildrenSymbol] = nodeChildren;
  }

  NodeChildren.create = function create(nodeChldren) {
    if (!nodeChldren) return null;
    return new NodeChildren(nodeChldren);
  }
  /**
   * 返回当前 children 实例所属的节点实例
   */
  ;

  var _proto = NodeChildren.prototype;

  /**
   * 是否为空
   * @returns
   */
  _proto.isEmpty = function isEmpty() {
    return this[nodeChildrenSymbol].isEmpty();
  }
  /**
   * 删除指定节点
   * @param node
   * @returns
   */
  ;

  _proto["delete"] = function _delete(node) {
    return this[nodeChildrenSymbol]["delete"](node[nodeSymbol]);
  }
  /**
   * 插入一个节点
   * @param node 待插入节点
   * @param at 插入下标
   * @returns
   */
  ;

  _proto.insert = function insert(node, at) {
    return this[nodeChildrenSymbol].insert(node[nodeSymbol], at, true);
  }
  /**
   * 返回指定节点的下标
   * @param node
   * @returns
   */
  ;

  _proto.indexOf = function indexOf(node) {
    return this[nodeChildrenSymbol].indexOf(node[nodeSymbol]);
  }
  /**
   * 类似数组 splice 操作
   * @param start
   * @param deleteCount
   * @param node
   */
  ;

  _proto.splice = function splice(start, deleteCount, node) {
    this[nodeChildrenSymbol].splice(start, deleteCount, node === null || node === void 0 ? void 0 : node[nodeSymbol]);
  }
  /**
   * 返回指定下标的节点
   * @param index
   * @returns
   */
  ;

  _proto.get = function get(index) {
    return this[nodeChildrenSymbol].get(index);
  }
  /**
   * 是否包含指定节点
   * @param node
   * @returns
   */
  ;

  _proto.has = function has(node) {
    return this[nodeChildrenSymbol].has(node[nodeSymbol]);
  }
  /**
   * 类似数组的 forEach
   * @param fn
   */
  ;

  _proto.forEach = function forEach(fn) {
    this[nodeChildrenSymbol].forEach(function (item, index) {
      fn(Node.create(item), index);
    });
  }
  /**
   * 类似数组的 map
   * @param fn
   */
  ;

  _proto.map = function map(fn) {
    return this[nodeChildrenSymbol].map(function (item, index) {
      return fn(Node.create(item), index);
    });
  }
  /**
   * 类似数组的 every
   * @param fn
   */
  ;

  _proto.every = function every(fn) {
    return this[nodeChildrenSymbol].every(function (item, index) {
      return fn(Node.create(item), index);
    });
  }
  /**
   * 类似数组的 some
   * @param fn
   */
  ;

  _proto.some = function some(fn) {
    return this[nodeChildrenSymbol].some(function (item, index) {
      return fn(Node.create(item), index);
    });
  }
  /**
   * 类似数组的 filter
   * @param fn
   */
  ;

  _proto.filter = function filter(fn) {
    return this[nodeChildrenSymbol].filter(function (item, index) {
      return fn(Node.create(item), index);
    }).map(function (item) {
      return Node.create(item);
    });
  }
  /**
   * 类似数组的 find
   * @param fn
   */
  ;

  _proto.find = function find(fn) {
    return Node.create(this[nodeChildrenSymbol].find(function (item, index) {
      return fn(Node.create(item), index);
    }));
  }
  /**
   * 类似数组的 reduce
   * @param fn
   */
  ;

  _proto.reduce = function reduce(fn, initialValue) {
    return this[nodeChildrenSymbol].reduce(function (acc, cur) {
      return fn(acc, Node.create(cur));
    }, initialValue);
  }
  /**
   * 导入 schema
   * @param data
   */
  ;

  _proto.importSchema = function importSchema(data) {
    this[nodeChildrenSymbol]["import"](data);
  }
  /**
   * 导出 schema
   * @param stage
   * @returns
   */
  ;

  _proto.exportSchema = function exportSchema(stage) {
    if (stage === void 0) {
      stage = TransformStage.Render;
    }

    return this[nodeChildrenSymbol]["export"](stage);
  }
  /**
   * 执行新增、删除、排序等操作
   * @param remover
   * @param adder
   * @param sorter
   */
  ;

  _proto.mergeChildren = function mergeChildren(remover, adder, sorter) {
    this[nodeChildrenSymbol].mergeChildren(function (node, idx) {
      return remover(Node.create(node), idx);
    }, function (children) {
      return adder(children.map(function (node) {
        return Node.create(node);
      }));
    }, function (firstNode, secondNode) {
      return sorter(Node.create(firstNode), Node.create(secondNode));
    });
  };

  _createClass(NodeChildren, [{
    key: "owner",
    get: function get() {
      return Node.create(this[nodeChildrenSymbol].owner);
    }
    /**
     * children 内的节点实例数
     */

  }, {
    key: "size",
    get: function get() {
      return this[nodeChildrenSymbol].size;
    }
  }]);

  return NodeChildren;
}();

export { NodeChildren as default };