import { Skeleton as InnerSkeleton, IWidgetBaseConfig } from '@alilc/lowcode-editor-skeleton';
import { skeletonSymbol } from './symbols';
export default class Skeleton {
    private readonly [skeletonSymbol];
    constructor(skeleton: InnerSkeleton);
    /**
     * 增加一个面板实例
     * @param config
     * @param extraConfig
     * @returns
     */
    add(config: IWidgetBaseConfig, extraConfig?: Record<string, any>): import("@alilc/lowcode-editor-skeleton/lib/widget/widget").IWidget | import("@alilc/lowcode-editor-skeleton/lib/widget/panel").default;
    /**
     * 移除一个面板实例
     * @param config
     * @returns
     */
    remove(config: IWidgetBaseConfig): void;
    /**
     * 显示面板
     * @param name
     */
    showPanel(name: string): void;
    /**
     * 隐藏面板
     * @param name
     */
    hidePanel(name: string): void;
    /**
     * 显示 widget
     * @param name
     */
    showWidget(name: string): void;
    /**
     * 隐藏 widget
     * @param name
     */
    hideWidget(name: string): void;
}
