import { skeletonSymbol } from './symbols';

var Skeleton = /*#__PURE__*/function () {
  function Skeleton(skeleton) {
    this[skeletonSymbol] = void 0;
    this[skeletonSymbol] = skeleton;
  }
  /**
   * 增加一个面板实例
   * @param config
   * @param extraConfig
   * @returns
   */


  var _proto = Skeleton.prototype;

  _proto.add = function add(config, extraConfig) {
    return this[skeletonSymbol].add(config, extraConfig);
  }
  /**
   * 移除一个面板实例
   * @param config
   * @returns
   */
  ;

  _proto.remove = function remove(config) {
    var area = config.area,
        name = config.name;
    var skeleton = this[skeletonSymbol];
    if (!normalizeArea(area)) return;
    skeleton[normalizeArea(area)].container.remove(name);
  }
  /**
   * 显示面板
   * @param name
   */
  ;

  _proto.showPanel = function showPanel(name) {
    var _this$skeletonSymbol$;

    (_this$skeletonSymbol$ = this[skeletonSymbol].getPanel(name)) === null || _this$skeletonSymbol$ === void 0 ? void 0 : _this$skeletonSymbol$.show();
  }
  /**
   * 隐藏面板
   * @param name
   */
  ;

  _proto.hidePanel = function hidePanel(name) {
    var _this$skeletonSymbol$2;

    (_this$skeletonSymbol$2 = this[skeletonSymbol].getPanel(name)) === null || _this$skeletonSymbol$2 === void 0 ? void 0 : _this$skeletonSymbol$2.hide();
  }
  /**
   * 显示 widget
   * @param name
   */
  ;

  _proto.showWidget = function showWidget(name) {
    var _this$skeletonSymbol$3;

    (_this$skeletonSymbol$3 = this[skeletonSymbol].getWidget(name)) === null || _this$skeletonSymbol$3 === void 0 ? void 0 : _this$skeletonSymbol$3.show();
  }
  /**
   * 隐藏 widget
   * @param name
   */
  ;

  _proto.hideWidget = function hideWidget(name) {
    var _this$skeletonSymbol$4;

    (_this$skeletonSymbol$4 = this[skeletonSymbol].getWidget(name)) === null || _this$skeletonSymbol$4 === void 0 ? void 0 : _this$skeletonSymbol$4.hide();
  };

  return Skeleton;
}();

export { Skeleton as default };

function normalizeArea(area) {
  switch (area) {
    case 'leftArea':
    case 'left':
      return 'leftArea';

    case 'rightArea':
    case 'right':
      return 'rightArea';

    case 'topArea':
    case 'top':
      return 'topArea';

    case 'toolbar':
      return 'toolbar';

    case 'mainArea':
    case 'main':
    case 'center':
    case 'centerArea':
      return 'mainArea';

    case 'bottomArea':
    case 'bottom':
      return 'bottomArea';

    case 'leftFixedArea':
      return 'leftFixedArea';

    case 'leftFloatArea':
      return 'leftFloatArea';

    case 'stages':
      return 'stages';
  }
}