/// <reference types="react" />
import { ComponentMeta as InnerComponentMeta } from '@alilc/lowcode-designer';
import { componentMetaSymbol } from './symbols';
export default class ComponentMeta {
    private readonly [componentMetaSymbol];
    constructor(componentMeta: InnerComponentMeta);
    static create(componentMeta: InnerComponentMeta | null): ComponentMeta;
    /**
     * 组件名
     */
    get componentName(): string;
    /**
     * 是否是「容器型」组件
     */
    get isContainer(): boolean;
    /**
     * 是否是最小渲染单元。
     * 当组件需要重新渲染时：
     *  若为最小渲染单元，则只渲染当前组件，
     *  若不为最小渲染单元，则寻找到上层最近的最小渲染单元进行重新渲染，直至根节点。
     */
    get isMinimalRenderUnit(): boolean;
    /**
     * 是否为「模态框」组件
     */
    get isModal(): boolean;
    /**
     * 元数据配置
     */
    get configure(): import("@alilc/lowcode-types").FieldConfig[];
    /**
     * 标题
     */
    get title(): string | import("react").ReactElement<any, string | ((props: any) => import("react").ReactElement<any, any>) | (new (props: any) => import("react").Component<any, any, any>)> | import("@alilc/lowcode-types").I18nData;
    /**
     * 图标
     */
    get icon(): any;
    /**
     * 组件 npm 信息
     */
    get npm(): any;
    /**
     * 设置 npm 信息
     * @param npm
     */
    setNpm(npm: any): void;
    /**
     * 获取元数据
     * @returns
     */
    getMetadata(): import("@alilc/lowcode-types").TransformedComponentMetadata;
}
