import { Dragon as InnerDragon, DragNodeDataObject } from '@alilc/lowcode-designer';
import { dragonSymbol } from './symbols';
export default class Dragon {
    private readonly [dragonSymbol];
    constructor(dragon: InnerDragon);
    static create(dragon: InnerDragon | null): Dragon;
    /**
     * 绑定 dragstart 事件
     * @param func
     * @returns
     */
    onDragstart(func: () => any): () => void;
    /**
     * 绑定 drag 事件
     * @param func
     * @returns
     */
    onDrag(func: () => any): () => void;
    /**
     * 绑定 dragend 事件
     * @param func
     * @returns
     */
    onDragend(func: () => any): () => void;
    /**
     * 设置拖拽监听的区域 shell，以及自定义拖拽转换函数 boost
     * @param shell 拖拽监听的区域
     * @param boost 拖拽转换函数
     */
    from(shell: Element, boost: (e: MouseEvent) => DragNodeDataObject | null): () => void;
}
