import { Editor as InnerEditor } from '@alilc/lowcode-editor-core';
import { editorSymbol } from './symbols';
declare type EventOptions = {
    prefix: string;
};
export default class Event {
    private readonly [editorSymbol];
    private readonly options;
    /**
     * 内核触发的事件名
     */
    readonly names: any[];
    constructor(editor: InnerEditor, options: EventOptions);
    /**
     * 监听事件
     * @param event 事件名称
     * @param listener 事件回调
     */
    on(event: string, listener: (...args: unknown[]) => void): void;
    /**
     * 取消监听事件
     * @param event 事件名称
     * @param listener 事件回调
     */
    off(event: string, listener: (...args: unknown[]) => void): void;
    /**
     * 触发事件
     * @param event 事件名称
     * @param args 事件参数
     * @returns
     */
    emit(event: string, ...args: unknown[]): void;
}
export declare function getEvent(editor: InnerEditor, options?: any): Event;
export {};
