"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _lowcodeDesigner = require("@alilc/lowcode-designer");

var _symbols = require("./symbols");

var _componentMeta = _interopRequireDefault(require("./component-meta"));

var Material = /*#__PURE__*/function () {
  function Material(editor) {
    this[_symbols.editorSymbol] = void 0;
    this[_symbols.designerSymbol] = void 0;
    this[_symbols.editorSymbol] = editor;
    this[_symbols.designerSymbol] = editor.get('designer');
  }
  /**
   * 获取组件 map 结构
   */


  var _proto = Material.prototype;

  /**
   * 设置「资产包」结构
   * @param assets
   * @returns
   */
  _proto.setAssets = function setAssets(assets) {
    return this[_symbols.editorSymbol].setAssets(assets);
  }
  /**
   * 获取「资产包」结构
   * @returns
   */
  ;

  _proto.getAssets = function getAssets() {
    return this[_symbols.editorSymbol].get('assets');
  }
  /**
   * 加载增量的「资产包」结构，该增量包会与原有的合并
   * @param incrementalAssets
   * @returns
   */
  ;

  _proto.loadIncrementalAssets = function loadIncrementalAssets(incrementalAssets) {
    return this[_symbols.designerSymbol].loadIncrementalAssets(incrementalAssets);
  }
  /**
   * 注册物料元数据管道函数
   * @param transducer
   * @param level
   * @param id
   */
  ;

  _proto.registerMetadataTransducer = function registerMetadataTransducer(transducer, level, id) {
    (0, _lowcodeDesigner.registerMetadataTransducer)(transducer, level, id);
  }
  /**
   * 获取所有物料元数据管道函数
   * @returns
   */
  ;

  _proto.getRegisteredMetadataTransducers = function getRegisteredMetadataTransducers() {
    return (0, _lowcodeDesigner.getRegisteredMetadataTransducers)();
  }
  /**
   * 获取指定名称的物料元数据
   * @param componentName
   * @returns
   */
  ;

  _proto.getComponentMeta = function getComponentMeta(componentName) {
    return _componentMeta["default"].create(this[_symbols.designerSymbol].getComponentMeta(componentName));
  }
  /**
   * 获取所有已注册的物料元数据
   * @returns
   */
  ;

  _proto.getComponentMetasMap = function getComponentMetasMap() {
    var map = new Map();

    var originalMap = this[_symbols.designerSymbol].getComponentMetasMap();

    for (var componentName in originalMap.keys()) {
      map.set(componentName, this.getComponentMeta(componentName));
    }

    return map;
  }
  /**
   * 在设计器辅助层增加一个扩展 action
   * @param action
   */
  ;

  _proto.addBuiltinComponentAction = function addBuiltinComponentAction(action) {
    (0, _lowcodeDesigner.addBuiltinComponentAction)(action);
  }
  /**
   * 移除设计器辅助层的指定 action
   * @param name
   */
  ;

  _proto.removeBuiltinComponentAction = function removeBuiltinComponentAction(name) {
    (0, _lowcodeDesigner.removeBuiltinComponentAction)(name);
  }
  /**
   * 修改已有的设计器辅助层的指定 action
   * @param actionName
   * @param handle
   */
  ;

  _proto.modifyBuiltinComponentAction = function modifyBuiltinComponentAction(actionName, handle) {
    (0, _lowcodeDesigner.modifyBuiltinComponentAction)(actionName, handle);
  }
  /**
   * 监听 assets 变化的事件
   * @param fn
   */
  ;

  _proto.onChangeAssets = function onChangeAssets(fn) {
    // 设置 assets，经过 setAssets 赋值
    this[_symbols.editorSymbol].onGot('assets', fn); // 增量设置 assets，经过 loadIncrementalAssets 赋值


    this[_symbols.editorSymbol].on('designer.incrementalAssetsReady', fn);
  };

  (0, _createClass2["default"])(Material, [{
    key: "componentsMap",
    get: function get() {
      return this[_symbols.designerSymbol].componentsMap;
    }
  }]);
  return Material;
}();

exports["default"] = Material;