"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _lowcodeTypes = require("@alilc/lowcode-types");

var _node = _interopRequireDefault(require("./node"));

var _symbols = require("./symbols");

var NodeChildren = /*#__PURE__*/function () {
  function NodeChildren(nodeChildren) {
    this[_symbols.nodeChildrenSymbol] = void 0;
    this[_symbols.nodeChildrenSymbol] = nodeChildren;
  }

  NodeChildren.create = function create(nodeChldren) {
    if (!nodeChldren) return null;
    return new NodeChildren(nodeChldren);
  }
  /**
   * 返回当前 children 实例所属的节点实例
   */
  ;

  var _proto = NodeChildren.prototype;

  /**
   * 是否为空
   * @returns
   */
  _proto.isEmpty = function isEmpty() {
    return this[_symbols.nodeChildrenSymbol].isEmpty();
  }
  /**
   * 删除指定节点
   * @param node
   * @returns
   */
  ;

  _proto["delete"] = function _delete(node) {
    return this[_symbols.nodeChildrenSymbol]["delete"](node[_symbols.nodeSymbol]);
  }
  /**
   * 插入一个节点
   * @param node 待插入节点
   * @param at 插入下标
   * @returns
   */
  ;

  _proto.insert = function insert(node, at) {
    return this[_symbols.nodeChildrenSymbol].insert(node[_symbols.nodeSymbol], at, true);
  }
  /**
   * 返回指定节点的下标
   * @param node
   * @returns
   */
  ;

  _proto.indexOf = function indexOf(node) {
    return this[_symbols.nodeChildrenSymbol].indexOf(node[_symbols.nodeSymbol]);
  }
  /**
   * 类似数组 splice 操作
   * @param start
   * @param deleteCount
   * @param node
   */
  ;

  _proto.splice = function splice(start, deleteCount, node) {
    this[_symbols.nodeChildrenSymbol].splice(start, deleteCount, node === null || node === void 0 ? void 0 : node[_symbols.nodeSymbol]);
  }
  /**
   * 返回指定下标的节点
   * @param index
   * @returns
   */
  ;

  _proto.get = function get(index) {
    return this[_symbols.nodeChildrenSymbol].get(index);
  }
  /**
   * 是否包含指定节点
   * @param node
   * @returns
   */
  ;

  _proto.has = function has(node) {
    return this[_symbols.nodeChildrenSymbol].has(node[_symbols.nodeSymbol]);
  }
  /**
   * 类似数组的 forEach
   * @param fn
   */
  ;

  _proto.forEach = function forEach(fn) {
    this[_symbols.nodeChildrenSymbol].forEach(function (item, index) {
      fn(_node["default"].create(item), index);
    });
  }
  /**
   * 类似数组的 map
   * @param fn
   */
  ;

  _proto.map = function map(fn) {
    return this[_symbols.nodeChildrenSymbol].map(function (item, index) {
      return fn(_node["default"].create(item), index);
    });
  }
  /**
   * 类似数组的 every
   * @param fn
   */
  ;

  _proto.every = function every(fn) {
    return this[_symbols.nodeChildrenSymbol].every(function (item, index) {
      return fn(_node["default"].create(item), index);
    });
  }
  /**
   * 类似数组的 some
   * @param fn
   */
  ;

  _proto.some = function some(fn) {
    return this[_symbols.nodeChildrenSymbol].some(function (item, index) {
      return fn(_node["default"].create(item), index);
    });
  }
  /**
   * 类似数组的 filter
   * @param fn
   */
  ;

  _proto.filter = function filter(fn) {
    return this[_symbols.nodeChildrenSymbol].filter(function (item, index) {
      return fn(_node["default"].create(item), index);
    }).map(function (item) {
      return _node["default"].create(item);
    });
  }
  /**
   * 类似数组的 find
   * @param fn
   */
  ;

  _proto.find = function find(fn) {
    return _node["default"].create(this[_symbols.nodeChildrenSymbol].find(function (item, index) {
      return fn(_node["default"].create(item), index);
    }));
  }
  /**
   * 类似数组的 reduce
   * @param fn
   */
  ;

  _proto.reduce = function reduce(fn, initialValue) {
    return this[_symbols.nodeChildrenSymbol].reduce(function (acc, cur) {
      return fn(acc, _node["default"].create(cur));
    }, initialValue);
  }
  /**
   * 导入 schema
   * @param data
   */
  ;

  _proto.importSchema = function importSchema(data) {
    this[_symbols.nodeChildrenSymbol]["import"](data);
  }
  /**
   * 导出 schema
   * @param stage
   * @returns
   */
  ;

  _proto.exportSchema = function exportSchema(stage) {
    if (stage === void 0) {
      stage = _lowcodeTypes.TransformStage.Render;
    }

    return this[_symbols.nodeChildrenSymbol]["export"](stage);
  }
  /**
   * 执行新增、删除、排序等操作
   * @param remover
   * @param adder
   * @param sorter
   */
  ;

  _proto.mergeChildren = function mergeChildren(remover, adder, sorter) {
    this[_symbols.nodeChildrenSymbol].mergeChildren(function (node, idx) {
      return remover(_node["default"].create(node), idx);
    }, function (children) {
      return adder(children.map(function (node) {
        return _node["default"].create(node);
      }));
    }, function (firstNode, secondNode) {
      return sorter(_node["default"].create(firstNode), _node["default"].create(secondNode));
    });
  };

  (0, _createClass2["default"])(NodeChildren, [{
    key: "owner",
    get: function get() {
      return _node["default"].create(this[_symbols.nodeChildrenSymbol].owner);
    }
    /**
     * children 内的节点实例数
     */

  }, {
    key: "size",
    get: function get() {
      return this[_symbols.nodeChildrenSymbol].size;
    }
  }]);
  return NodeChildren;
}();

exports["default"] = NodeChildren;