"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _symbols = require("./symbols");

var _node = _interopRequireDefault(require("./node"));

var _settingTopEntry = _interopRequireDefault(require("./setting-top-entry"));

var SettingPropEntry = /*#__PURE__*/function () {
  function SettingPropEntry(prop) {
    this[_symbols.settingPropEntrySymbol] = void 0;
    this[_symbols.settingPropEntrySymbol] = prop;
  }

  SettingPropEntry.create = function create(prop) {
    return new SettingPropEntry(prop);
  }
  /**
   * 获取设置属性的 name
   */
  ;

  var _proto = SettingPropEntry.prototype;

  /**
   * @deprecated use .node instead
   */
  _proto.getNode = function getNode() {
    return this.node;
  }
  /**
   * @deprecated use .parent instead
   */
  ;

  _proto.getParent = function getParent() {
    return this.parent;
  }
  /**
   * 设置值
   * @param val 值
   */
  ;

  _proto.setValue = function setValue(val) {
    this[_symbols.settingPropEntrySymbol].setValue(val);
  }
  /**
   * 设置子级属性值
   * @param propName 子属性名
   * @param value 值
   */
  ;

  _proto.setPropValue = function setPropValue(propName, value) {
    this[_symbols.settingPropEntrySymbol].setPropValue(propName, value);
  }
  /**
   * 获取值
   * @returns
   */
  ;

  _proto.getValue = function getValue() {
    return this[_symbols.settingPropEntrySymbol].getValue();
  }
  /**
   * 获取设置属性集
   * @returns
   */
  ;

  _proto.getProps = function getProps() {
    return _settingTopEntry["default"].create(this[_symbols.settingPropEntrySymbol].getProps());
  }
  /**
   * 是否绑定了变量
   * @returns
   */
  ;

  _proto.isUseVariable = function isUseVariable() {
    return this[_symbols.settingPropEntrySymbol].isUseVariable();
  }
  /**
   * 设置绑定变量
   * @param flag
   */
  ;

  _proto.setUseVariable = function setUseVariable(flag) {
    this[_symbols.settingPropEntrySymbol].setUseVariable(flag);
  }
  /**
   * 创建一个设置 field 实例
   * @param config
   * @returns
   */
  ;

  _proto.createField = function createField(config) {
    return SettingPropEntry.create(this[_symbols.settingPropEntrySymbol].createField(config));
  }
  /**
   * 获取值，当为变量时，返回 mock
   * @returns
   */
  ;

  _proto.getMockOrValue = function getMockOrValue() {
    return this[_symbols.settingPropEntrySymbol].getMockOrValue();
  };

  (0, _createClass2["default"])(SettingPropEntry, [{
    key: "name",
    get: function get() {
      return this[_symbols.settingPropEntrySymbol].name;
    }
    /**
     * 获取设置属性的 key
     */

  }, {
    key: "key",
    get: function get() {
      return this[_symbols.settingPropEntrySymbol].getKey();
    }
    /**
     * 获取设置属性对应的节点实例
     */

  }, {
    key: "node",
    get: function get() {
      return _node["default"].create(this[_symbols.settingPropEntrySymbol].getNode());
    }
    /**
     * 获取设置属性的父设置属性
     */

  }, {
    key: "parent",
    get: function get() {
      return SettingPropEntry.create(this[_symbols.settingPropEntrySymbol].parent);
    }
  }]);
  return SettingPropEntry;
}();

exports["default"] = SettingPropEntry;